/*
 * GPS_RX.c
 *
 *  Created on: 17.10.2014
 *      Author: DL9MWE
 */
#include "main.h"


/*
$PGACK,103*40
$PGACK,105*46
$PMTK011,MTKGPS*08
$PMTK010,001*2E
$PMTK010,002*2D
$GPGGA,235944.800,,,,,0,0,,,M,,M,,*4D
$GPGSA,A,1,,,,,,,,,,,,,,,*1E
$GPRMC,235944.800,V,,,,,0.00,0.00,050180,,,N*44
$GPVTG,0.00,T,,M,0.00,N,0.00,K,N*32
$GPGGA,235945.800,,,,,0,0,,,M,,M,,*4C
$GPGSA,A,1,,,,,,,,,,,,,,,*1E
$GPRMC,235945.800,V,,,,,0.00,0.00,050180,,,N*45
$GPVTG,0.00,T,,M,0.00,N,0.00,K,N*32

$GPGGA,084241.000,5223.5949,N,00948.3830,E,1,4,1.42,84.8,M,47.0,M,,*69
$GPGSA,A,3,16,05,08,31,,,,,,,,,1.71,1.42,0.95*06
$GPRMC,084241.000,A,5223.5949,N,00948.3830,E,0.45,123.77,171014,,,A*6C
$GPVTG,123.77,T,,M,0.45,N,0.84,K,A*30
$GPGGA,084242.000,5223.5949,N,00948.3832,E,1,4,1.42,84.7,M,47.0,M,,*67
$GPGSA,A,3,16,05,08,31,,,,,,,,,1.71,1.42,0.95*06
$GPRMC,084242.000,A,5223.5949,N,00948.3832,E,0.46,123.77,171014,,,A*6E
$GPVTG,123.77,T,,M,0.46,N,0.84,K,A*33
 */

unsigned int GPS_init(void) {
	return 1;
}


unsigned int strcmp(char *s1, char *s2) {
	unsigned int index=0;
	do {
		if(s1[index]) {
			if(s1[index] == s2[index])
				continue;
		}
		return 0;
	} while(s2[++index]);
	return 1;
}

unsigned int csv_cpy(unsigned char *s1, unsigned char *s2, unsigned int max) {
	unsigned int index=0;
	while(s1[index]) {
		if(s1[index] != ',') {
			if(index <= max)
				s2[index] = s1[index];
		} else break;
		++index;
	}
	s2[++index] = '\0';
	return index;
}

unsigned char uchex2char(char *hex) {
	unsigned char  result;
	result = ucASCIItoNibble(hex[0]) << 4;
	result |= ucASCIItoNibble(hex[1]);
	return result;
}

unsigned int crc_check(unsigned char *zeile) {
	char crc = '\0';
	unsigned int index = 0;
	while(zeile[++index]) {
		if(zeile[index] != '*') {
			crc ^= zeile[index]; // XOR
		} else break;
	}
	return crc == uchex2char((char *)&zeile[index+1]);
}

unsigned int csv_getindex(unsigned char *zeile, unsigned int value_number) {
	unsigned int index = 0;
	while(value_number--) {
		while(zeile[index]) {
			if(zeile[index++] == ',')
				break;
		}
	}
	return index;
}

void GPRMC_line(unsigned char *zeile) {
	unsigned int index=7;
	if(zeile[csv_getindex(zeile, 2)] == 'A') {	// gltige RMC-Daten?
		index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.UTC, len_UTC);
		index += 2;		// gltige Daten (skip "A,")
		index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.latitude, len_latitude);
		index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.N_S, len_N_S);
		index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.longitude, len_longitude);
		index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.E_W, len_E_W);
		index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.ground_speed_knots, len_ground_speed_knots);
		index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.track_angle, len_track_angle);
		index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.date, len_date);
	}
}


/* GGA          Global Positioning System Fix Data
123519       Fix taken at 12:35:19 UTC
4807.038,N   Latitude 48 deg 07.038' N
01131.000,E  Longitude 11 deg 31.000' E
1            Fix quality: 0 = invalid
                          1 = GPS fix (SPS)
                          2 = DGPS fix
                          3 = PPS fix
		       4 = Real Time Kinematic
		       5 = Float RTK
                          6 = estimated (dead reckoning) (2.3 feature)
		       7 = Manual input mode
		       8 = Simulation mode
08           Number of satellites being tracked
0.9          Horizontal dilution of position
545.4,M      Altitude, Meters, above mean sea level
46.9,M       Height of geoid (mean sea level) above WGS84
                 ellipsoid
(empty field) time in seconds since last DGPS update
(empty field) DGPS station ID number
*/
//                        1         2         3         4         5         6         7
//              01234567890123456789012345678901234567890123456789012345678901234567890
//char gga[] = "$GPGGA,084720.000,5223.5987,N,00948.3793,E,1,6,1.04,82.5,M,47.0,M,,*64";

void GPGGA_line(unsigned char *zeile) {
	unsigned int index=7;

	if(zeile[csv_getindex(zeile, 6)] != '0') {	// gltige GGA-Daten?
		index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.UTC, len_UTC);
		index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.latitude, len_latitude);
		index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.N_S, len_N_S);
		index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.longitude, len_longitude);
		index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.E_W, len_E_W);
		index += 2;		// skip "1,"
		index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.satellites_used, len_satellites_used);
		index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.hor_dilution, len_hor_dilution);
		index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.height_asl, len_height_asl);
		index += 2;		// skip "M,"
		index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.height_geoid, len_height_geoid);
	}
}

/*
$GPGSA,A,3,04,05,,09,12,,,24,,,,,2.5,1.3,2.1*39

Where:
   GSA      Satellite status
   A        Auto selection of 2D or 3D fix (M = manual)
   3        3D fix - values include: 1 = no fix
                                     2 = 2D fix
                                     3 = 3D fix
   04,05... PRNs of satellites used for fix (space for 12)
   2.5      PDOP (dilution of precision)
   1.3      Horizontal dilution of precision (HDOP)
   2.1      Vertical dilution of precision (VDOP)
   *39      the checksum data, always begins with *
*/
//$GPGSA,A,3,16,05,08,31,29,21,,,,,,,1.35,1.04,0.85*0D
void GPGSA_line(unsigned char *zeile) {
	unsigned int index=9, count;
	index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.fix, 1);
	for(count=0; count < 12; ++count) {
		index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.PRN[count], len_PRN);
	}
	index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.PDOP, len_PDOP);
	index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.HDOP, len_HDOP);
	index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.VDOP, len_VDOP);
}


//$GPVTG,123.77,T,,M,0.06,N,0.12,K,A*38
void GPVTG_line(unsigned char *zeile) {
	unsigned int index=7;
	index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.true_track, len_true_track);
	index += 2;		// skip "T,"
	index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.magnetic_track, len_magnetic_track);
	index += 2;		// skip "M,"
	index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.ground_speed_knots, len_ground_speed_knots);
	index += 2;		// skip "N,"
	index += csv_cpy(&zeile[index], SystemStatus.messwerte.GPS_RX.ground_speed_km_h, len_ground_speed_km_h);
}

void GPS_check(void) {
	unsigned int UARTline_index;
#if 0
	//                      1         2         3         4         5         6         7
	//            01234567890123456789012345678901234567890123456789012345678901234567890
//	char rmc[] = "$GPRMC,084242.000,A,5223.5949,N,00948.3832,E,0.46,123.77,171014,,,A*6E";
	char rmc[] = "$GPRMC,235944.800,V,,,,,0.00,0.00,050180,,,N*44";

	for(UARTline_index = 0; rmc[UARTline_index]; ++UARTline_index) {
		UARTlines[0].zeile[UARTline_index] = rmc[UARTline_index];
	}
	UARTlines[0].valid = Ja;
	char vtg[] = "$GPVTG,123.77,T,,M,0.06,N,0.12,K,A*38";
	for(UARTline_index = 0; vtg[UARTline_index]; ++UARTline_index) {
		UARTlines[1].zeile[UARTline_index] = vtg[UARTline_index];
	}
	UARTlines[1].valid = Ja;

#if 0
	//                      1         2         3         4         5         6         7
	//            01234567890123456789012345678901234567890123456789012345678901234567890
	char gsa[] = "$GPGSA,A,3,16,05,08,31,29,21,,,,,,,1.35,1.04,0.85*0D";
	for(UARTline_index = 0; gsa[UARTline_index]; ++UARTline_index) {
		UARTlines[0].zeile[UARTline_index] = gsa[UARTline_index];
	}
	UARTlines[0].valid = Ja;
	//                      1         2         3         4         5         6         7
	//            01234567890123456789012345678901234567890123456789012345678901234567890
	char gga[] = "$GPGGA,084720.000,5223.5987,N,00948.3793,E,1,6,1.04,82.5,M,47.0,M,,*64";
	for(UARTline_index = 0; gga[UARTline_index]; ++UARTline_index) {
		UARTlines[1].zeile[UARTline_index] = gga[UARTline_index];
	}
	UARTlines[1].valid = Ja;
#endif
#endif

	for(UARTline_index=0; UARTline_index <= 1; ++UARTline_index) {
		if(UARTlines[UARTline_index].valid == Ja) {
			if(crc_check(UARTlines[UARTline_index].zeile)) {
				if(strcmp((char*)UARTlines[UARTline_index].zeile, "$GPRMC")) {
					GPRMC_line(UARTlines[UARTline_index].zeile);
				} else if(strcmp((char*)UARTlines[UARTline_index].zeile, "$GPGGA")) {
					GPGGA_line(UARTlines[UARTline_index].zeile);
				} else if(strcmp((char*)UARTlines[UARTline_index].zeile, "$GPGSA")) {
					GPGSA_line(UARTlines[UARTline_index].zeile);
				} else if(strcmp((char*)UARTlines[UARTline_index].zeile, "$GPVTG")) {
					GPVTG_line(UARTlines[UARTline_index].zeile);
				}
			}
			UARTlines[UARTline_index].valid = Nein;
		}
	}
}


// Ende GPS_RX.c
