/*
 * GPS_RX.h
 *
 *  Created on: 17.10.2014
 *      Author: DL9MWE
 */

#ifndef GPS_RX_H_
#define GPS_RX_H_

#define len_true_track			 6
#define len_magnetic_track		 6
#define len_UTC 				10
#define len_latitude			 9
#define len_N_S					 1
#define len_longitude			10
#define len_E_W					 1
#define len_ground_speed_knots	 7
#define	len_ground_speed_km_h	 7
#define len_track_angle			 6
#define len_date				 6

#define len_satellites_used		 2
#define len_hor_dilution		 4
#define len_height_asl			 7
#define len_height_geoid		 7

#define len_fix					 1
#define len_PRN					 2
#define len_PDOP				 3
#define len_HDOP				 3
#define len_VDOP				 3
typedef struct {
	//RMC-Daten
	unsigned char UTC[len_UTC+1];				// hhmmss.mmm
	unsigned char latitude[len_latitude+1];
	unsigned char N_S[len_N_S+1];
	unsigned char longitude[len_longitude+1];
	unsigned char E_W[len_E_W+1];
	unsigned char ground_speed_knots[len_ground_speed_knots+1];
	unsigned char track_angle[len_track_angle+1];
	unsigned char date[len_date+1];				// ttmmyy

	// zustzliche GGA-Daten
	unsigned char satellites_used[len_satellites_used+1];
	unsigned char hor_dilution[len_hor_dilution+1];
	unsigned char height_asl[len_height_asl+1];
	unsigned char height_geoid[len_height_geoid+1];

	// zustzliche GSA-Daten
	unsigned char fix[len_fix+1];				// 1: nofix, 2: 2D-fix, 3: 3D-fix
	unsigned char PRN[12][len_PRN+1];			// Satellites
	unsigned char PDOP[len_PDOP+1];				// dilution
	unsigned char HDOP[len_HDOP+1];
	unsigned char VDOP[len_VDOP+1];

	// zustzliche VTG-Daten
	unsigned char true_track[len_true_track+1];			// True Heading TH in Grad
	unsigned char magnetic_track[len_magnetic_track+1];//	char ground_speed_knots[8];
	unsigned char ground_speed_km_h[len_ground_speed_km_h+1];

} GPS_werte_t;



unsigned int GPS_init(void);
void GPS_check(void);

#endif /* GPS_RX_H_ */
