/*
 * PCF8574A.c
 * I2C I/O-Expander zur Ansteuerung eines LCD-Displays (hier Displaytech 162)
 * LCD_I2C nutzt die Bits 0..5
 * Zwei Eingabetasten liegen an den Bits 6 und 7 (zur freien Verfgung)
 *
 *  Created on: 21.10.2014
 *      Author: DL9MWE
 *      09.02.2015
 */
#include "main.h"


unsigned int ui16PCF8574A_init(void) {
#if 0	// Interrupt vom PCF wird z.Zt. nicht benutzt
	// Port-Pin fr den Interrupt vom PCF8574A konfigurieren
	PORTPCF_DIR &= ~PCFINT_BIT;
	PORTPCF_IES |= PCFINT_BIT;		// detect high-low transition
	PORTPCF_IE |= PCFINT_BIT;		// Interrupt enable
	// probeweise schreiben
#endif
	return ui16I2C_Start_write8Bit_Stop(PCF8574A_I2C_ADDRESS, 0xC0);
}


unsigned int ui16PCF8574A_out(unsigned char byte) {
	// Byte an den Port-expander senden, dabei Bit7 = Bit6 = 1 (PCF8574A-Input)
	return ui16I2C_Start_write8Bit_Stop(PCF8574A_I2C_ADDRESS, byte | 0xC0);
}

uint8_t ui8PCF8574A_in(uint16_t *error_code) {
	return ui8I2C_Start_read8Bit_Stop(PCF8574A_I2C_ADDRESS, error_code);
}

#if 0	// Interrupt vom PCF wird z.Zt. nicht benutzt

// Port interrupt service routine
#pragma vector=PORTPCF_VECTOR
__interrupt void PORTPCF_ISR(void) {
	// Interrupt von der Porterweiterung?
	if(PORTPCF_IFG & PCFINT_BIT) {
		PORTPCF_IFG &= ~PCFINT_BIT;		// clear this interrupt flag
	}
}
#endif

/* Ende PCF8574A.c */
