/*
 * hilfsfunktionen.c
 *
 *  Created on: 21.09.2014
 *      Author: DL9MWE
 */

#include "main.h"

// *********************  Umwandlung von int bzw. long in ASCII-Zeichen  *********************
// fhrende Nullen werden umgesetzt
//  "Nachkommastellen" (hier als'.' gedruckt) knnen angegeben werden
//  es wird kein! String erzeugt. D.h. ein abschlieendes '\x00' wird nicht gesetzt

//                         ***  Subroutines  ***
char cldigit(unsigned long *uiX, unsigned char stelle) {
  unsigned long y, wert=1;
  char data;
	while(stelle) {
		wert = wert * 10;
		--stelle;
	}
	y = *uiX/wert;
	data = y+0x30;
	*uiX -= y*wert;
	return data;
}
unsigned char ultoChars(unsigned long value, unsigned char* asciiChars, unsigned char komma, unsigned char stellen) {
	unsigned char index = 0;
	while(stellen--) {
		asciiChars[index] = cldigit(&value, stellen);
		if(komma && komma == stellen) {
			asciiChars[++index] = '.';
		}
		++index;
	}
	return index;
}
unsigned char ltoChars(long value, unsigned char* asciiChars, unsigned char komma, unsigned char stellen, Ja_Nein_t trim) {
	unsigned char index=0;


	if(value < 0) {			// Vorzeichen bearbeiten
		value = -value;
		asciiChars[index++] = '-';
	}
	index += ultoChars((unsigned long)value, asciiChars+index, komma, stellen);
	return index;
}


// ***************  diese Funktionen werden von auen verwendet  ***************
unsigned char itochars(int value, unsigned char* asciiChars, unsigned char komma) {
// wandelt ein int in ASCII-Zeichen um.
//  der Stringpointer *asciiChars muss auf ein ausreichend groes Array (min. 7) zeigen!
//  Komma gibt die Anzahl "Nachkommastellen" an, trim = 1: fhrende Nullen unterdrcken
//  Rckgabe: Anzahl gltiger Zeichen
	return ltoChars((long) value, asciiChars, komma, 4, Nein/*notrim*/);
}

unsigned char ltochars(long value, unsigned char* asciiChars, unsigned char komma) {
// wandelt ein long int in ASCII-Zeichen um.
//  der Stringpointer *asciiChars muss auf ein ausreichend groes Array (min. 12) zeigen!
//  Komma gibt die Anzahl "Nachkommastellen" an, trim = 1: fhrende Nullen unterdrcken
//  Rckgabe: Anzahl gltiger Zeichen
	return ltoChars(value, asciiChars, komma, 9, Nein/*notrim*/);
}

unsigned char uitochars(unsigned int value, unsigned char* asciiChars, unsigned char komma, unsigned char stellen) {
	return ultoChars((unsigned long) value, asciiChars, komma, stellen);
}

//---------------------------------------------
unsigned char ucASCIItoNibble(unsigned char digit)
{
	if ( digit<='9' )
    {
        return(digit-'0');
    }else if (digit>='A'&& digit<='F')
    {
        return((digit-'A')+10);
    }else
    {
        if(digit>='a' && digit<='f')
        {
            return((digit-'a')+10);
        }
    }
    return 0;
}
// Ende Hilfsfunktionen.c




