/*
 * main.h
 *
 *  Created on: 19.09.2014
 *      Author: M
 */

#ifndef MAIN_H_
#define MAIN_H_

#define F_MHZ 16		// CPU-Taktfrequenz
#define LCD				// verwende LCD via I2C

#define SW_I2C			// I2C-Schnittstelle via Software
//#define HW_I2C			// verwende Gerrits I2C-Hardware Funktionen

typedef enum Ja_Nein { Ja, Nein } Ja_Nein_t;

#include <msp430.h>
#include <stdint.h>

#include "LCD_I2C.h"
#include "PCF8574A.h"
#include "I2C.h"
#include "SW_I2C_lowlevel.h"
#include "BMP180.h"
#include "hilfsfunktionen.h"
#include "USCIA0_UART.h"
#include "GPS_RX.h"


typedef struct {
	Ja_Nein_t	LCDok;			// LCD (I2C)
	Ja_Nein_t	BMP180ok;		// Luftdruck-Sensor (I2C)
	Ja_Nein_t	GPS_RXok;		// adafruit GPS-Rx
} devicesOK_t;


typedef struct {
	bmp180_werte_t		bmp180;		// Luftdruck und Temperatur
	GPS_werte_t			GPS_RX;		// GPS-Empfnger
} messwerte_t;


typedef struct {
	devicesOK_t				devices;
	messwerte_t				messwerte;
} SystemStatus_t;
extern SystemStatus_t SystemStatus;



void vCPU_init(void);
void _delay_us(volatile unsigned int usec);
void _delay_ms(volatile unsigned int msec);

#endif /* MAIN_H_ */
